/*******************************************************************/
/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program: Klaus Schneider,  VC


Program Description:
--------------------

This program draws an ellipse inside the window.

*/
/*******************************************************************/

#include <vcrt.h>
#include <flib.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>

/*******************************************************************/

void main(void)

  {
  int   Image;
  image window;

    /*******************************************************************************/
    /*                 PLEASE INITIALIZE YOUR LICENCE CODES                        */
    /*                    To activate library functions                            */
    /*                                                                             */
    /* VCLIB :         init_licence("T1122334455") or init_licence("LT1122334455") */
    /* Extension Lib : init_licence("E1122334455") or init_licence("LE1122334455") */
    /* Color Lib :     init_licence("C1122334455") or init_licence("LC1122334455") */
    /* etc.                                                                        */
    /*                                                                             */
    /*      init_licence() returns 0 if licence code is OK, -5 otherwise           */
    /*                                                                             */
    /* Example :                                                                   */
    /*                                                                             */
	/**/ 	print("Init VCLIB = %d\n", init_licence("T1122334455"));			 /**/
    /*******************************************************************************/

  vmode(vmLive);

  /* get the actual values for the screen */   
  Image   = (int)ScrGetPhysPage;
  ScrSetLogPage(Image);

  /* Take pictures */
  tpict();

  /* Display pictures */
  ImageAssign(&window, ScrByteAddr(100,100),300,300,ScrGetPitch);
  framed(&window, 128);
  markerd(&window, 64);
  ellipsed(&window, 32); 
  
  vmode(vmStill);
  }

/*******************************************************************/


