#if !defined(AFX_ATXCONTROLCTL_H__2FEC5222_09F0_4595_9324_FB2DA37E8957__INCLUDED_)
#define AFX_ATXCONTROLCTL_H__2FEC5222_09F0_4595_9324_FB2DA37E8957__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// AtXControlCtl.h : Declaration of the CAtXControlCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CAtXControlCtrl : See AtXControlCtl.cpp for implementation.
#include "atAsyncSocket.h"
#include "Observer.h"
#define RECVBUFSIZE 1024
#define SENDBUFSIZE 1024




class CAtXControlCtrl : public COleControl, public CObserver
{
	DECLARE_DYNCREATE(CAtXControlCtrl)

// Constructor
public:
	CAtXControlCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAtXControlCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	virtual DWORD GetControlFlags();
	//}}AFX_VIRTUAL

// Implementation
protected:
	HBITMAP m_hBmp;
	unsigned char m_bmpInfo[sizeof(BITMAPINFOHEADER) + 256 * sizeof(RGBQUAD)];
	BOOL CreatePicture(unsigned char * image, int x0, int y0, int dx, int dy, int ix, int iy);
	CDC * m_pDC;
	CBitmap * m_pBmp;
	//CBitmap * m_pOldBmp;

//	UINT m_Timer;
	unsigned char * m_pixmap;
	BOOL m_bLive;
	unsigned char * m_pixar;
	BOOL m_busy;
	int m_Cnt;
	int m_Size;
	int m_picX;
	int m_picY;
	int m_picDX;
	int m_picDY;
	int m_picIX;
	int m_picIY;
	char m_rBuffer[RECVBUFSIZE];
	char m_sBuffer[SENDBUFSIZE];

	CString m_serverName;
	long m_port;
	void Disconnect(void);
	CatAsyncSocket m_Client;
	~CAtXControlCtrl();

	DECLARE_OLECREATE_EX(CAtXControlCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CAtXControlCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CAtXControlCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CAtXControlCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CAtXControlCtrl)
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CAtXControlCtrl)
	afx_msg BSTR GetServer();
	afx_msg void SetServer(LPCTSTR lpszNewValue);
	afx_msg long GetPort();
	afx_msg void SetPort(long nNewValue);
	afx_msg BOOL GetBusy();
	afx_msg void SetBusy(BOOL bNewValue);
	afx_msg BOOL GetLive();
	afx_msg void SetLive(BOOL bNewValue);
	afx_msg void RequestImage(long x, long y, long dx, long dy, long incrx, long incry);
	afx_msg void SetPosition(long x, long y, long dx, long dy);
	afx_msg void Abort();
	afx_msg BOOL SaveToBmp(LPCTSTR fileName);
	afx_msg void GetImgAttrib(long FAR* x, long FAR* y, long FAR* dx, long FAR* dy);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CAtXControlCtrl)
	void FirePictureReady(long status)
		{FireEvent(eventidPictureReady,EVENT_PARAM(VTS_I4), status);}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	virtual void Update(CSubject * pSubject);
	enum {
	//{{AFX_DISP_ID(CAtXControlCtrl)
	dispidServer = 1L,
	dispidPort = 2L,
	dispidBusy = 3L,
	dispidLive = 4L,
	dispidRequestImage = 5L,
	dispidSetPosition = 6L,
	dispidAbort = 7L,
	dispidSaveToBmp = 8L,
	dispidGetImgAttrib = 9L,
	eventidPictureReady = 1L,
	//}}AFX_DISP_ID
	};

protected:

public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	
//	afx_msg void OnTimer(UINT nIDEvent);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ATXCONTROLCTL_H__2FEC5222_09F0_4595_9324_FB2DA37E8957__INCLUDED)
