// atxClient.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "atxClient.h"
#include "atxClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CatxClientApp

BEGIN_MESSAGE_MAP(CatxClientApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


// CatxClientApp construction

CatxClientApp::CatxClientApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CatxClientApp object

CatxClientApp theApp;


// CatxClientApp initialization

BOOL CatxClientApp::InitInstance()
{
	CWinApp::InitInstance();

	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();


	CatxClientDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}


BOOL StoreWindowPosition(CWnd * pWnd, char * keyname)
{
	HKEY hKey;
	BOOL r = FALSE;
	RECT rc;
	if(strlen(keyname) > 0)
	{
		if(RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\atto-Systems\\atxCClient", 0, KEY_WRITE, & hKey) == ERROR_SUCCESS)
		{
			::GetWindowRect(pWnd->GetSafeHwnd(), & rc); 
			r = RegSetValueEx(hKey, keyname, 0, REG_BINARY, (LPBYTE) & rc, sizeof(rc)) == ERROR_SUCCESS ? TRUE : FALSE;
			RegCloseKey(hKey);
		}
	}
	return r;
}

BOOL RetrieveWindowPosition(CWnd * pWnd, char * keyname, BOOL bChild)
{
	BOOL r = FALSE;
	HKEY hKey;
	RECT rc;
	DWORD type, size;
	if(strlen(keyname) > 0)
	{
		if(RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\atto-Systems\\atxCClient", 0, KEY_READ, & hKey) == ERROR_SUCCESS)
		{
			type = REG_BINARY;
			size = sizeof(RECT);

			if(RegQueryValueEx(hKey, keyname, 0, & type, (LPBYTE) & rc, & size) == ERROR_SUCCESS)
			{
				if(type == REG_BINARY && size == sizeof(RECT))
				{
					if(bChild)
						pWnd->GetOwner()->ScreenToClient(& rc);

					pWnd->MoveWindow(& rc);
					r = TRUE;
				}
			}

			RegCloseKey(hKey);
		}
	}
	return r;
}