// atxClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "atxClient.h"
#include "atxClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW 
#endif


// CAboutDlg dialog used for App About


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	protected:
	//{{AFX_VIRTUAL(CAboutDlg)
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
//{{AFX_MSG_MAP(CAboutDlg)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()



// CatxClientDlg dialog



CatxClientDlg::CatxClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CatxClientDlg::IDD, pParent)
	, m_server(_T(""))
	, m_port(2002)
	, m_orgX(0)
	, m_orgY(0)
	, m_width(640)
	, m_height(480)
	, m_sX(1)
	, m_sY(1)
	, m_bLive(0)
{
	//{{AFX_DATA_INIT(CatxClientDlg)
	m_bLive = FALSE;
	m_status = _T("");
	m_t_status = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CatxClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CatxClientDlg)
	DDX_Control(pDX, IDC_SAVEBMP, m_saveBmp);
	DDX_Control(pDX, IDC_ATXCONTROLCTRL, m_ctrl);
	DDX_Text(pDX, IDC_ORGX, m_orgX);
	DDX_Text(pDX, IDC_ORGY, m_orgY);
	DDX_Text(pDX, IDC_WIDTH, m_width);
	DDX_Text(pDX, IDC_HEIGHT, m_height);
	DDX_Text(pDX, IDC_IX, m_sX);
	DDX_Text(pDX, IDC_IY, m_sY);
	DDX_Control(pDX, IDC_GETIMAGE, m_getImage);
	DDX_Control(pDX, IDC_ABORT, m_abort);
	DDX_Check(pDX, IDC_LIVEMODE, m_bLive);
	DDX_Text(pDX, IDC_SERVER, m_server);
	DDX_Text(pDX, IDC_PORT, m_port);
	DDX_Text(pDX, IDC_PIC_STATUS, m_status);
	DDX_Text(pDX, IDC_TR_STATUS, m_t_status);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CatxClientDlg, CDialog)
	//{{AFX_MSG_MAP(CatxClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_GETIMAGE, OnBnClickedGetimage)
	ON_BN_CLICKED(IDC_ABORT, OnBnClickedAbort)
	ON_BN_CLICKED(IDC_SAVEBMP, OnSavebmp)
	ON_BN_CLICKED(IDC_LIVEMODE, OnLivemode)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
//	ON_BN_CLICKED(IDC_SETPOS, OnBnClickedSetpos)
//	ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()


// CatxClientDlg message handlers

BOOL CatxClientDlg::OnInitDialog()
{

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	HKEY hKey;
	DWORD dw, type, size;
	if(!RetrieveWindowPosition(this, "dialog", FALSE))
	{
	
		RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\atto-Systems\\atxCClient", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, & hKey, & dw);
		RegCloseKey(hKey);
		StoreWindowPosition(this, "inidialog");
	}
	if(RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\atto-Systems\\atxCClient", 0, KEY_READ, & hKey) == ERROR_SUCCESS)
	{
		type = REG_BINARY;
		size = sizeof(RECT);

		RegQueryValueEx(hKey, "inidialog", 0, & type, (LPBYTE) & m_defWRect, & size);
		ClientToScreen(& m_defWRect);
		ASSERT(type == REG_BINARY && size == sizeof(RECT));
		RegCloseKey(hKey);
	}


	RetrieveWindowPosition((CWnd *) & m_ctrl, "atx", TRUE);


	UpdateData(FALSE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CatxClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CatxClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CatxClientDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CatxClientDlg::OnBnClickedGetimage()
{
	UpdateData(TRUE);
	m_ctrl.SetPort(m_port);
	m_ctrl.SetServer(m_server);
	if(m_orgX < 0 || m_orgY < 0 || m_height < 0 || m_height < 0 || m_sX <= 0 || m_sY <= 0)
	{
		AfxMessageBox("Invalid value!");
		return;
	}
	m_status = "Request for new image selected.";
	UpdateData(FALSE);
	m_ctrl.SetLive(m_bLive);
	m_ctrl.RequestImage(m_orgX, m_orgY, m_width, m_height, m_sX, m_sY);
}

void CatxClientDlg::OnBnClickedAbort()
{
	m_ctrl.Abort();
}


BEGIN_EVENTSINK_MAP(CatxClientDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CatxClientDlg)
	ON_EVENT(CatxClientDlg, IDC_ATXCONTROLCTRL, 1 /* PictureReady */, OnPictureReadyAtxcontrolctrl, VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CatxClientDlg::OnPictureReadyAtxcontrolctrl(long status) 
{
	CRect rc[3];
	long x, y, dx, dy;
	static DWORD dw[3];
	if(status == 9)
		dw[2] = GetTickCount();
	if(status == 8)
		dw[0] = GetTickCount();


	if(status == 0)
	{
		dw[1] = GetTickCount();
		m_t_status.Format("Last image received for %ld ms", dw[1] - dw[2]);
		m_status.Format("Last image rendered for %ld ms.", dw[1] - dw[0]);

		m_ctrl.GetImgAttrib(& x, & y, & dx, & dy);


		GetWindowRect(& rc[0]);


		m_ctrl.GetWindowRect(& rc[1]);
		
		
		ScreenToClient(& rc[1]);
		rc[2] = rc[1];

		rc[1].right = rc[1].left + dx;
		rc[1].bottom = rc[1].top + dy;
		
		
		rc[0].right += (rc[1].Width() - rc[2].Width());
		rc[0].bottom += (rc[1].Height() - rc[2].Height());

		if(rc[0].Height() < m_defWRect.Height())
			rc[0].bottom = rc[0].top + m_defWRect.Height();
		if(rc[0].Width() < m_defWRect.Width())
			rc[0].right = rc[0].left + m_defWRect.Width();





		MoveWindow(& rc[0]);
		m_ctrl.SetPosition(rc[1].left, rc[1].top, rc[1].Width(), rc[1].Height());

	}
	
	if(status == 4)
	{
		m_t_status.Format("Send ERROR!");
	}
	if(status == 1)
		m_t_status.Format("Connection with server lost.");
	if(status == 2)
		m_t_status.Format("No server to connect to.");
	UpdateData(FALSE);
}

void CatxClientDlg::OnSavebmp() 
{
	CFileDialog fd(FALSE, "bmp", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Bitmap files(*.bmp)|*.bmp|All files(*.*)|*.*||", this);
	if(fd.DoModal() == IDOK)
		m_ctrl.SaveToBmp(fd.GetPathName());
}

BOOL CatxClientDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	if(pMsg->hwnd == m_ctrl.GetSafeHwnd() && pMsg->message == WM_LBUTTONDOWN)
		return TRUE;
	return CDialog::PreTranslateMessage(pMsg);
}

void CatxClientDlg::OnLivemode() 
{
	UpdateData(TRUE);
	m_ctrl.SetLive(m_bLive);
	m_saveBmp.EnableWindow(!m_bLive);
}

void CatxClientDlg::OnDestroy() 
{
	StoreWindowPosition((CWnd *) & m_ctrl, "atx");
	StoreWindowPosition(this, "dialog");
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	
}
