/*******************************************************************/
/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program: Klaus Schneider,  VC


Program Description:
--------------------

FOR VC/RT 5.X
This program starts trigtask.exe.

06/07/07 : updated to exec3() LB

*/
/*******************************************************************/

#include <vcrt.h>
#include <vclib.h>
#include <macros.h>
#include <sysvar.h>

/*******************************************************************/

int main()
{	
    int id;
    static char * fname = "fd:/trigtask.exe";
	int Priority = 4;                 /* Priority 4 */
    int Timeslice = 10;               /* Timeslice 10ms (standard value) */

    id = exec3(Priority, Timeslice, fname, (void *)0);
    print("starting trigtask with id= %d priority %d\n", id, getvar(TPRIORITY));
    return(0);
}

/*******************************************************************/

