#if !defined(MESSAGES_H_INCLUDED)
#define MESSAGES_H_INCLUDED

//communication events

#define ATSOCK_ONCONNECT	0x1000
#define ATSOCK_ONCLOSE		0x1001
#define ATSOCK_ONRECEIVE	0x1002
#define ATSOCK_ONSEND		0x1003
#define ATSOCK_ONACCEPT		0x1004
// error codes
#define ATERR_NOERROR		0x0000 // no error
#define ATERR_DISCONNECT	0x0001 // connection terminated
#define ATERR_NOSERVER		0x0002 // no server to connect to
#define ATERR_RECVERROR		0x0003 // receive error
#define ATERR_SENDERROR		0x0004 // send error
#define ATERR_RECVTOUT		0x0005 // receive timeout
#define ATERR_INVALIDPARAM	0x0006 // invalid picture parameter received
#define ATERR_NOMEM			0x0007 // not enough memory
#define ATERR_PICRECV		0x0008 // new picture has begun


// internal communication
#define ATNOTF_RQSEND		0x0009


typedef struct tagATSOCK_COMMAND
{
	void * data;
	void * extra;
	long command;
	
} ATSOCK_COMMAND;

#endif